背景:
适用于由GRUB引导的CentOS,Ubuntu,Debian系统. 使用官方发行版去掉模板预装的软件. 同时也可以解决内核版本与软件不兼容的问题。 只要有root权限,还您一个纯净的系统。
相关文章:
[ Linux VPS ] CentOS 网络安装/重装系统一键脚本 纯净安装
注意:
全自动安装默认root密码:Vicer,安装完成后请立即更改密码. 请使用 passwd root 命令更改密码. 特别注意:OpenVZ构架不适用.
更新:
[2018.04.03]
功能合并: [ Linux VPS ] Debian/Ubuntu/CentOS 网络安装/重装系统/纯净安装 一键脚本
[2018.03.30]
优化GRUB检测测逻辑. 添加组件依赖检测. 修复一些已知BUG.
[2018.03.25]
优化判断逻辑. 增加手动指定网络参数选项,可有效避免自动获取网络参数无效造成无法直接联网的问题.
[2017.11.25]
重新规范参数-d/-u.
[2017.11.22]
增加自动dd安装Windows功能,点击查看详情.
[2017.08.06]
增加支持重装为Ubuntu系统 安装Ubuntu时,必须使用版本代号. 如有必要,请使用--mirror自行更换软件源. 使用方法示例:
以自动模式安装Ubuntu 16.04 64位为例:
bashDebianNET.sh-uxenial-v64-a
[2017.07.05]
修复在独服上安装的一些由硬盘引起的问题. 修复在CentOS6上判断网卡出错的问题.
[2017.06.25]
适配了由较老GRUB版本引导的CentOS6等系统. 去除-cn参数,此参数作用不大. 添加-apt/--mirror参数,用于指定源(需完整的镜像源地址). 用法示例:
--mirror 'http://ftp.riken.jp/Linux/debian/debian/'--mirror 'http://mirrors.ustc.edu.cn/debian/'
[2017.06.24]
由公网探测IP地址,改为本机探测IP地址.适配更加广泛.
[2017.06.23]
修复Debian9不能使用root登陆的问题. 移除对于route命令的依赖,使用ip命令并计算子网掩码. 修复使用ls命令时的一个错误警告. 增加-cn参数,使国内机器下载所需资源更加迅速.
[2017.06.20]
增加对Debian9的支持,支持全自动化安装. 未做大量测试,有问题请反馈.
[2017.06.09]
添加支持从CentOS7运行全自动化安装Debian. 理论上支持由grub2引导的系统(CentOS6由grub引导,故不支持.). 优化判断逻辑,删除 -t参数. 添加-a参数(全自动化安装)和-m参数(从VNC模式安装)
[2017.06.05]
修复全自动安装Debian8会出现卡住和不能使用root密码登陆的问题.
[2017.06.04]
增加全自动方式安装,实现在无救援模式,无VNC的情况下安装Debian. 已在AWS Lightsail(Ubuntu),DigitalOcean,UltraVPS.eu通过测试. 默认root密码:Vicer,安装完成后请立即更改密码. 使用 passwd root 命令更改密码.
[2017.03.28]
增加了一个之参数选项; 此参数用于手动指定机器的虚拟化类型。 一般情况下不需要指定此参数。
[2017.03.25]
修复了一些已知问题。
需要:
1.Debian/Ubuntu/CentOS 系统(由GRUB引导); 2.wget 用来下载文件,获取公网IP; 3.ip 获取网关,掩码等; 4.sed awk grep 处理文本流; 5.VNC 安装系统(此项为可选)。
确保安装了所需软件:
#Debian/Ubuntu:apt-get install -ygawk sedgrep#RedHat/CentOS:yum install -ygawk sedgrep
如果出现了错误,请运行:
#Debian/Ubuntu:apt-get update#RedHat/CentOS:yum update
一键下载及使用:
wget--no-check-certificate -qO DebianNET.sh'https://moeclub.org/attachment/LinuxShell/DebianNET.sh'&& chmod a+x DebianNET.sh
Usage: bash DebianNET.sh -d/--debian [dist-name]-u/--ubuntu [dist-name]-v/--ver [32/i386|64/amd64]--ip-addr/--ip-gate/--ip-mask-apt/--mirror-dd/--image-a/-m
全自动/非全自动示例:
全自动安装:
bashDebianNET.sh-dwheezy-vi386-a
VNC手动安装:
bashDebianNET.sh-dwheezy-vi386-m
全自动安装(指定网络参数):
# 将X.X.X.X替换为自己的网络参数.# --ip-addr :IP Address/IP地址# --ip-gate :Gateway /网关# --ip-mask :Netmask /子网掩码#bash DebianNET.sh -d wheezy -v i386 -a --ip-addr X.X.X.X --ip-mask X.X.X.X --ip-gate X.X.X.X
使用示例:
【默认】安装Debian 7 x32:
bashDebianNET.sh-dwheezy-vi386
bashDebianNET.sh-d7-v32
安装Debian 8 x64:
bashDebianNET.sh-djessie-vamd64
bashDebianNET.sh-d8-v64
安装Debian 9 x64:
bashDebianNET.sh-dstretch-vamd64
bashDebianNET.sh-d9-v64
安装Ubuntu 14.04 x64:
bashDebianNET.sh-utrusty-v64
安装Ubuntu 16.04 x64:
bashDebianNET.sh-uxenial-v64
安装Ubuntu 18.04 x64:
bashDebianNET.sh-ubionic-v64
【默认】预览:
完整代码:
#!/bin/bashexport tmpVER=''export tmpDIST=''export tmpURL=''export tmpWORD=''export tmpMirror=''export tmpSSL=''export tmpINS=''export tmpFW=''export ipAddr=''export ipMask=''export ipGate=''export linuxdists=''export ddMode='0'export setNet='0'export isMirror='0'export FindDists='0'while [[ $# -ge 1 ]]; do case $1 in -v|--ver) shift tmpVER="$1" shift ;; -d|--debian) shift linuxdists='debian' tmpDIST="$1" shift ;; -u|--ubuntu) shift linuxdists='ubuntu' tmpDIST="$1" shift ;; -dd|--image) shift ddMode='1' tmpURL="$1" shift ;; -p|--password) shift tmpWORD="$1" shift ;; --ip-addr) shift ipAddr="$1" shift ;; --ip-mask) shift ipMask="$1" shift ;; --ip-gate) shift ipGate="$1" shift ;; -a|--auto) shift tmpINS='auto' ;; -m|--manual) shift tmpINS='manual' ;; -apt|--mirror) shift isMirror='1' tmpMirror="$1" shift ;; -ssl) shift tmpSSL="$1" shift ;; --firmware) shift tmpFW='1' ;; *) echo -ne " Usage:\n\tbash DebianNET.sh\t-d/--debian [\033[33m\033[04mdists-name\033[0m]\n\t\t\t\t-u/--ubuntu [\033[04mdists-name\033[0m]\n\t\t\t\t-v/--ver [32/\033[33m\033[04mi386\033[0m|64/amd64]\n\t\t\t\t--ip-addr/--ip-gate/--ip-mask\n\t\t\t\t-apt/--mirror\n\t\t\t\t-dd/--image\n\t\t\t\t-a/--auto\n\t\t\t\t-m/--manual\n" exit 1; ;; esac done[[ "$EUID" -ne '0' ]] && echo "Error:This script must be run as root!" && exit 1;function CheckDependence(){FullDependence='0';for BIN_DEP in `echo "$1" |sed 's/,/\n/g'` do if [[ -n "$BIN_DEP" ]]; then Founded='0'; for BIN_PATH in `echo "$PATH" |sed 's/:/\n/g'` do ls $BIN_PATH/$BIN_DEP >/dev/null 2>&1; if [ $? == '0' ]; then Founded='1'; break; fi done if [ "$Founded" == '1' ]; then echo -en "$BIN_DEP\t\t[\033[32mok\033[0m]\n"; else FullDependence='1'; echo -en "$BIN_DEP\t\t[\033[31mfail\033[0m]\n"; fi fi doneif [ "$FullDependence" == '1' ]; then exit 1;fi}clear && echo -e "\n\033[36m# Check Dependence\033[0m\n"CheckDependence wget,awk,grep,sed,cut,cat,cpio,gzip[ "$ddMode" == '1' ] && {CheckDependence iconv}[[ -f '/boot/grub/grub.cfg' ]] && GRUBOLD='0' && GRUBDIR='/boot/grub' && GRUBFILE='grub.cfg';[[ -z "$GRUBDIR" ]] && [[ -f '/boot/grub2/grub.cfg' ]] && GRUBOLD='0' && GRUBDIR='/boot/grub2' && GRUBFILE='grub.cfg';[[ -z "$GRUBDIR" ]] && [[ -f '/boot/grub/grub.conf' ]] && GRUBOLD='1' && GRUBDIR='/boot/grub' && GRUBFILE='grub.conf';[ -z "$GRUBDIR" -o -z "$GRUBFILE" ] && echo -ne "Error! \nNot Found grub path.\n" && exit 1;[[ -n "$tmpVER" ]] && { [ "$tmpVER" == '32' -o "$tmpVER" == 'i386' ] && VER='i386'; [ "$tmpVER" == '64' -o "$tmpVER" == 'amd64' ] && VER='amd64';}[[ -z "$VER" ]] && VER='i386';[[ -z "$linuxdists" ]] && linuxdists='debian';[[ "$isMirror" == '1' ]] && [[ -n "$tmpMirror" ]] && { tmpDebianMirror="$(echo -n "$tmpMirror" |grep -Eo '.*\.(\w+)')"; echo -n "$tmpDebianMirror" |grep -q '://'; [[ $? -eq '0' ]] && { DebianMirror="$(echo -n "$tmpDebianMirror" |awk -F'://' '{print $2}')"; } || { DebianMirror="$(echo -n "$tmpDebianMirror")"; }} || { [[ "$linuxdists" == 'debian' ]] && DebianMirror='httpredir.debian.org'; [[ "$linuxdists" == 'ubuntu' ]] && DebianMirror='archive.ubuntu.com';}[[ -z "$DebianMirrorDirectory" ]] && [[ -n "$DebianMirror" ]] && [[ -n "$tmpMirror" ]] && { DebianMirrorDirectory="$(echo -n "$tmpMirror" |awk -F''${DebianMirror}'' '{print $2}' |sed 's/\/$//g')";}[[ -n "$DebianMirror" ]] && { [[ "$DebianMirrorDirectory" == '/' ]] && { [[ "$linuxdists" == 'debian' ]] && DebianMirrorDirectory='/debian'; [[ "$linuxdists" == 'ubuntu' ]] && DebianMirrorDirectory='/ubuntu'; } [[ -z "$DebianMirrorDirectory" ]] && { [[ "$linuxdists" == 'debian' ]] && DebianMirrorDirectory='/debian'; [[ "$linuxdists" == 'ubuntu' ]] && DebianMirrorDirectory='/ubuntu'; }}[[ -z "$tmpDIST" ]] && { [[ "$linuxdists" == 'debian' ]] && DIST='wheezy'; [[ "$linuxdists" == 'ubuntu' ]] && DIST='trusty';}[[ -z "$DIST" ]] && { DIST="$(echo "$tmpDIST" |sed -r 's/(.*)/\L\1/')"; echo "$DIST" |grep -q '[0-9]'; [[ $? -eq '0' ]] && { isDigital="$(echo "$DIST" |grep -o '[0-9\.]\{1,\}' |sed -n '1h;1!H;$g;s/\n//g;$p' |cut -d'.' -f1)"; [[ -n $isDigital ]] && { [[ "$isDigital" == '7' ]] && DIST='wheezy'; [[ "$isDigital" == '8' ]] && DIST='jessie'; [[ "$isDigital" == '9' ]] && DIST='stretch'; [[ "$isDigital" == '10' ]] && DIST='buster'; } }}[[ "$ddMode" == '1' ]] && { [[ -n "$tmpURL" ]] && { linuxdists='debian'; DIST='jessie'; VER='amd64'; tmpINS='auto'; DDURL="$tmpURL" echo "$DDURL" |grep -q '^http://\|^ftp://\|^https://'; [[ $? -ne '0' ]] && echo 'Please input vaild URL,Only support http://, ftp:// and https:// !' && exit 1; [[ -n "$tmpSSL" ]] && SSL_SUPPORT="$tmpSSL"; [[ -z "$SSL_SUPPORT" ]] && SSL_SUPPORT='https://moeclub.org/get-wget_udeb_amd64'; } || { echo 'Please input vaild URL! '; exit 1; }}DistsList="$(wget --no-check-certificate -qO- "http://$DebianMirror$DebianMirrorDirectory/dists/" |grep -o 'href=.*/"' |cut -d'"' -f2 |sed '/-\|old\|Debian\|experimental\|stable\|test\|sid\|devel/d' |grep '^[^/]' |sed -n '1h;1!H;$g;s/\n//g;s/\//\;/g;$p')";for CheckDEB in `echo "$DistsList" |sed 's/;/\n/g'` do [[ "$CheckDEB" == "$DIST" ]] && FindDists='1'; [[ "$FindDists" == '1' ]] && break; done[[ "$FindDists" == '0' ]] && { echo -ne '\nThe dists version not found, Please check it! \n\n' bash $0 error; exit 1;}[[ -n "$tmpINS" ]] && { [[ "$tmpINS" == 'auto' ]] && inVNC='n'; [[ "$tmpINS" == 'manual' ]] && inVNC='y';}[ -n "$ipAddr" ] && [ -n "$ipMask" ] && [ -n "$ipGate" ] && setNet='1';[[ -n "$tmpWORD" ]] && myPASSWORD="$tmpWORD";[[ -n "$tmpFW" ]] && INCFW="$tmpFW";[[ -z "$myPASSWORD" ]] && myPASSWORD='Vicer';[[ -z "$INCFW" ]] && INCFW='0';clear && echo -e "\n\033[36m# Install\033[0m\n"ASKVNC(){ inVNC='y'; [[ "$ddMode" == '0' ]] && { echo -ne "\033[34mCan you login VNC?\033[0m\e[33m[\e[32my\e[33m/n]\e[0m " read tmpinVNC [[ -n "$tmpinVNC" ]] && inVNCtmp="$tmpinVNC" } [ "$inVNCtmp" == 'y' -o "$inVNCtmp" == 'Y' ] && inVNC='y'; [ "$inVNCtmp" == 'n' -o "$inVNCtmp" == 'N' ] && inVNC='n';}[ "$inVNC" == 'y' -o "$inVNC" == 'n' ] || ASKVNC;[[ "$linuxdists" == 'debian' ]] && LinuxName='Debian';[[ "$linuxdists" == 'ubuntu' ]] && LinuxName='Ubuntu';[[ "$ddMode" == '0' ]] && { [[ "$inVNC" == 'y' ]] && echo -e "\033[34mManual Mode\033[0m insatll \033[33m$LinuxName\033[0m [\033[33m$DIST\033[0m] [\033[33m$VER\033[0m] in VNC. " [[ "$inVNC" == 'n' ]] && echo -e "\033[34mAuto Mode\033[0m insatll \033[33m$LinuxName\033[0m [\033[33m$DIST\033[0m] [\033[33m$VER\033[0m]. "}[[ "$ddMode" == '1' ]] && { echo -ne "\033[34mAuto Mode\033[0m insatll \033[33mWindows\033[0m\n[\033[33m$DDURL\033[0m]\n"}echo -e "\n[\033[33m$LinuxName\033[0m] [\033[33m$DIST\033[0m] [\033[33m$VER\033[0m] Downloading..."[[ -z "$DebianMirror" ]] && echo -ne "\033[31mError! \033[0mGet debian mirror fail! \n" && exit 1[[ -z "$DebianMirrorDirectory" ]] && echo -ne "\033[31mError! \033[0mGet debian mirror directory fail! \n" && exit 1wget --no-check-certificate -qO '/boot/initrd.gz' "http://$DebianMirror$DebianMirrorDirectory/dists/$DIST/main/installer-$VER/current/images/netboot/$linuxdists-installer/$VER/initrd.gz"[[ $? -ne '0' ]] && echo -ne "\033[31mError! \033[0mDownload 'initrd.gz' failed! \n" && exit 1wget --no-check-certificate -qO '/boot/linux' "http://$DebianMirror$DebianMirrorDirectory/dists/$DIST/main/installer-$VER/current/images/netboot/$linuxdists-installer/$VER/linux"[[ $? -ne '0' ]] && echo -ne "\033[31mError! \033[0mDownload 'linux' failed! \n" && exit 1[[ "$INCFW" == '1' ]] && [[ "$linuxdists" == 'debian' ]] && { wget --no-check-certificate -qO '/boot/firmware.cpio.gz' "http://cdimage.debian.org/cdimage/unofficial/non-free/firmware/$DIST/current/firmware.cpio.gz" [[ $? -ne '0' ]] && echo -ne "\033[31mError! \033[0mDownload 'firmware' failed! \n" && exit 1}[[ "$setNet" == '1' ]] && { IPv4="$ipAddr"; MASK="$ipMask"; GATE="$ipGate";} || { DEFAULTNET="$(ip route show |grep -o 'default via [0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.*' |head -n1 |sed 's/proto.*\|onlink.*//g' |awk '{print $NF}')"; [[ -n "$DEFAULTNET" ]] && IPSUB="$(ip addr |grep ''${DEFAULTNET}'' |grep 'global' |grep 'brd' |head -n1 |grep -o '[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}/[0-9]\{1,2\}')"; IPv4="$(echo -n "$IPSUB" |cut -d'/' -f1)"; NETSUB="$(echo -n "$IPSUB" |grep -o '/[0-9]\{1,2\}')"; GATE="$(ip route show |grep -o 'default via [0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}' |head -n1 |grep -o '[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}')"; [[ -n "$NETSUB" ]] && MASK="$(echo -n '128.0.0.0/1,192.0.0.0/2,224.0.0.0/3,240.0.0.0/4,248.0.0.0/5,252.0.0.0/6,254.0.0.0/7,255.0.0.0/8,255.128.0.0/9,255.192.0.0/10,255.224.0.0/11,255.240.0.0/12,255.248.0.0/13,255.252.0.0/14,255.254.0.0/15,255.255.0.0/16,255.255.128.0/17,255.255.192.0/18,255.255.224.0/19,255.255.240.0/20,255.255.248.0/21,255.255.252.0/22,255.255.254.0/23,255.255.255.0/24,255.255.255.128/25,255.255.255.192/26,255.255.255.224/27,255.255.255.240/28,255.255.255.248/29,255.255.255.252/30,255.255.255.254/31,255.255.255.255/32' |grep -o '[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}'${NETSUB}'' |cut -d'/' -f1)";}[[ -n "$GATE" ]] && [[ -n "$MASK" ]] && [[ -n "$IPv4" ]] || {echo "Not found \`ip command\`, It will use \`route command\`."ipNum() { local IFS='.'; read ip1 ip2 ip3 ip4 <<<"$1"; echo $((ip1*(1<<24)+ip2*(1<<16)+ip3*(1<<8)+ip4));}SelectMax(){ii=0;for IPITEM in `route -n |awk -v OUT=$1 '{print $OUT}' |grep '[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}'` do NumTMP="$(ipNum $IPITEM)"; eval "arrayNum[$ii]='$NumTMP,$IPITEM'"; ii=$[$ii+1]; doneecho ${arrayNum[@]} |sed 's/\s/\n/g' |sort -n -k 1 -t ',' |tail -n1 |cut -d',' -f2;}[[ -z $IPv4 ]] && IPv4="$(ifconfig |grep 'Bcast' |head -n1 |grep -o '[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}.[0-9]\{1,3\}' |head -n1)";[[ -z $GATE ]] && GATE="$(SelectMax 2)";[[ -z $MASK ]] && MASK="$(SelectMax 3)";[[ -n "$GATE" ]] && [[ -n "$MASK" ]] && [[ -n "$IPv4" ]] || { echo "Error! Not configure network. "; exit 1;}}[[ "$setNet" != '1' ]] && [[ -f '/etc/network/interfaces' ]] && { [[ -z "$(sed -n '/iface.*inet static/p' /etc/network/interfaces)" ]] && AutoNet='1' || AutoNet='0'; [[ -d /etc/network/interfaces.d ]] && { ICFGN="$(find /etc/network/interfaces.d -name '*.cfg' |wc -l)" || ICFGN='0'; [[ "$ICFGN" -ne '0' ]] && { for NetCFG in `ls -1 /etc/network/interfaces.d/*.cfg` do [[ -z "$(cat $NetCFG | sed -n '/iface.*inet static/p')" ]] && AutoNet='1' || AutoNet='0'; [[ "$AutoNet" -eq '0' ]] && break; done } }}[[ "$setNet" != '1' ]] && [[ -d '/etc/sysconfig/network-scripts' ]] && { ICFGN="$(find /etc/sysconfig/network-scripts -name 'ifcfg-*' |grep -v 'lo'|wc -l)" || ICFGN='0'; [[ "$ICFGN" -ne '0' ]] && { for NetCFG in `ls -1 /etc/sysconfig/network-scripts/ifcfg-* |grep -v 'lo$' |grep -v ':[0-9]\{1,\}'` do [[ -n "$(cat $NetCFG | sed -n '/BOOTPROTO.*[dD][hH][cC][pP]/p')" ]] && AutoNet='1' || { AutoNet='0' && . $NetCFG; [[ -n $NETMASK ]] && MASK="$NETMASK"; [[ -n $GATEWAY ]] && GATE="$GATEWAY"; } [[ "$AutoNet" -eq '0' ]] && break; done }}[[ ! -f $GRUBDIR/$GRUBFILE ]] && echo "Error! Not Found $GRUBFILE. " && exit 1;[[ ! -f $GRUBDIR/$GRUBFILE.old ]] && [[ -f $GRUBDIR/$GRUBFILE.bak ]] && mv -f $GRUBDIR/$GRUBFILE.bak $GRUBDIR/$GRUBFILE.old;mv -f $GRUBDIR/$GRUBFILE $GRUBDIR/$GRUBFILE.bak;[[ -f $GRUBDIR/$GRUBFILE.old ]] && cat $GRUBDIR/$GRUBFILE.old >$GRUBDIR/$GRUBFILE || cat $GRUBDIR/$GRUBFILE.bak >$GRUBDIR/$GRUBFILE;[[ "$GRUBOLD" == '0' ]] && { READGRUB='/tmp/grub.read' cat $GRUBDIR/$GRUBFILE |sed -n '1h;1!H;$g;s/\n/+++/g;$p' |grep -oPm 1 'menuentry\ .*\{.*\}\+\+\+' |sed 's/\+\+\+/\n/g' >$READGRUB LoadNum="$(cat $READGRUB |grep -c 'menuentry ')" if [[ "$LoadNum" -eq '1' ]]; then cat $READGRUB |sed '/^$/d' >/tmp/grub.new; elif [[ "$LoadNum" -gt '1' ]]; then CFG0="$(awk '/menuentry /{print NR}' $READGRUB|head -n 1)"; CFG2="$(awk '/menuentry /{print NR}' $READGRUB|head -n 2 |tail -n 1)"; CFG1=""; for tmpCFG in `awk '/}/{print NR}' $READGRUB` do [ "$tmpCFG" -gt "$CFG0" -a "$tmpCFG" -lt "$CFG2" ] && CFG1="$tmpCFG"; done [[ -z "$CFG1" ]] && { echo "Error! read $GRUBFILE. "; exit 1; } sed -n "$CFG0,$CFG1"p $READGRUB >/tmp/grub.new; [[ -f /tmp/grub.new ]] && [[ "$(grep -c '{' /tmp/grub.new)" -eq "$(grep -c '}' /tmp/grub.new)" ]] || { echo -ne "\033[31mError! \033[0mNot configure $GRUBFILE. \n"; exit 1; } fi [ ! -f /tmp/grub.new ] && echo "Error! $GRUBFILE. " && exit 1; sed -i "/menuentry.*/c\menuentry\ \'Install OS \[$DIST\ $VER\]\'\ --class debian\ --class\ gnu-linux\ --class\ gnu\ --class\ os\ \{" /tmp/grub.new sed -i "/echo.*Loading/d" /tmp/grub.new;}[[ "$GRUBOLD" == '1' ]] && { CFG0="$(awk '/title /{print NR}' $GRUBDIR/$GRUBFILE|head -n 1)"; CFG1="$(awk '/title /{print NR}' $GRUBDIR/$GRUBFILE|head -n 2 |tail -n 1)"; [[ -n $CFG0 ]] && [ -z $CFG1 -o $CFG1 == $CFG0 ] && sed -n "$CFG0,$"p $GRUBDIR/$GRUBFILE >/tmp/grub.new; [[ -n $CFG0 ]] && [ -z $CFG1 -o $CFG1 != $CFG0 ] && sed -n "$CFG0,$CFG1"p $GRUBDIR/$GRUBFILE >/tmp/grub.new; [[ ! -f /tmp/grub.new ]] && echo "Error! configure append $GRUBFILE. " && exit 1; sed -i "/title.*/c\title\ \'Install OS \[$DIST\ $VER\]\'" /tmp/grub.new; sed -i '/^#/d' /tmp/grub.new;}[[ -n "$(grep 'linux.*/\|kernel.*/' /tmp/grub.new |awk '{print $2}' |tail -n 1 |grep '^/boot/')" ]] && Type='InBoot' || Type='NoBoot';LinuxKernel="$(grep 'linux.*/\|kernel.*/' /tmp/grub.new |awk '{print $1}' |head -n 1)";[[ -z "$LinuxKernel" ]] && echo "Error! read grub config! " && exit 1;LinuxIMG="$(grep 'initrd.*/' /tmp/grub.new |awk '{print $1}' |tail -n 1)";[ -z "$LinuxIMG" ] && sed -i "/$LinuxKernel.*\//a\\\tinitrd\ \/" /tmp/grub.new && LinuxIMG='initrd';[[ "$Type" == 'InBoot' ]] && { sed -i "/$LinuxKernel.*\//c\\\t$LinuxKernel\\t\/boot\/linux auto=true hostname=$linuxdists domain= -- quiet" /tmp/grub.new; sed -i "/$LinuxIMG.*\//c\\\t$LinuxIMG\\t\/boot\/initrd.gz" /tmp/grub.new;}[[ "$Type" == 'NoBoot' ]] && { sed -i "/$LinuxKernel.*\//c\\\t$LinuxKernel\\t\/linux auto=true hostname=$linuxdists domain= -- quiet" /tmp/grub.new; sed -i "/$LinuxIMG.*\//c\\\t$LinuxIMG\\t\/initrd.gz" /tmp/grub.new;}sed -i '$a\\n' /tmp/grub.new;[[ "$inVNC" == 'n' ]] && {GRUBPATCH='0';[ -f '/etc/network/interfaces' -o -d '/etc/sysconfig/network-scripts' ] || { echo "Error, Not found interfaces config."; exit 1;}INSERTGRUB="$(awk '/menuentry /{print NR}' $GRUBDIR/$GRUBFILE|head -n 1)"sed -i ''${INSERTGRUB}'i\\n' $GRUBDIR/$GRUBFILE;sed -i ''${INSERTGRUB}'r /tmp/grub.new' $GRUBDIR/$GRUBFILE;[[ -f $GRUBDIR/grubenv ]] && sed -i 's/saved_entry/#saved_entry/g' $GRUBDIR/grubenv;[[ -d /boot/tmp ]] && rm -rf /boot/tmp;mkdir -p /boot/tmp;cd /boot/tmp;gzip -d < ../initrd.gz | cpio --extract --verbose --make-directories --no-absolute-filenames >>/dev/null 2>&1cat >/boot/tmp/preseed.cfg<'/boot/tmp/net.tmp';
}
WinNoDHCP(){
echo -ne "@ECHO OFF\r\ncd\056\076\045windir\045\GetAdmin\r\nif\040exist\040\045windir\045\GetAdmin\040\050del\040\057f\040\057q\040\042\045windir\045\GetAdmin\042\051\040else\040\050\r\necho\040CreateObject^\050\042Shell\056Application\042^\051\056ShellExecute\040\042\045~s0\042\054\040\042\045\052\042\054\040\042\042\054\040\042runas\042\054\040\061\040\076\076\040\042\045temp\045\Admin\056vbs\042\r\n\042\045temp\045\Admin\056vbs\042\r\ndel\040\057f\040\057q\040\042\045temp\045\Admin\056vbs\042\r\nexit\040\057b\040\062\051\r\nfor\040\057f\040\042tokens=\063\052\042\040\045\045i\040in\040\050\047netsh\040interface\040show\040interface\040^|more\040+3\040^|findstr\040\057R\040\042\u672c\u5730\056\052\040\u4ee5\u592a\056\052\040Local\056\052\040Ethernet\042\047\051\040do\040\050set\040EthName=\045\045j\051\r\nnetsh\040-c\040interface\040ip\040set\040address\040name=\042\045EthName\045\042\040source=static\040address=$IPv4\040mask=$MASK\040gateway=$GATE\r\nnetsh\040-c\040interface\040ip\040add\040dnsservers\040name=\042\045EthName\045\042\040address=\070\056\070\056\070\056\070\040index=1\040validate=no\r\nnetsh\040-c\040interface\040ip\040add\040dnsservers\040name=\042\045EthName\045\042\040address=\070\056\070\056\064\056\064\040index=2\040validate=no\r\ncd\040\057d\040\042\045ProgramData\045\057Microsoft\057Windows\057Start\040Menu\057Programs\057Startup\042\r\ndel\040\057f\040\057q\040net\056bat\r\n\r\n" >'/boot/tmp/net.tmp';
}
[[ "$setNet" == '1' ]] && WinNoDHCP;
[[ "$setNet" == '0' ]] && {
[[ "$AutoNet" -eq '1' ]] && WinDHCP;
[[ "$AutoNet" -eq '0' ]] && WinNoDHCP;
}
iconv -f 'UTF-8' -t 'GBK' '/boot/tmp/net.tmp' -o '/boot/tmp/net.bat'
rm -rf '/boot/tmp/net.tmp'
echo "$DDURL" |grep -q '^https://'
[[ $? -eq '0' ]] && {
echo -ne '\nAdd ssl support...\n'
[[ -n $SSL_SUPPORT ]] && {
wget --no-check-certificate -qO- "$SSL_SUPPORT" |tar -x
[[ ! -f /boot/tmp/usr/bin/wget ]] && echo 'Error! SSL_SUPPORT.' && exit 1;
sed -i 's/wget\ -qO-/\/usr\/bin\/wget\ --no-check-certificate\ --retry-connrefused\ --tries=7\ --continue\ -qO-/g' /boot/tmp/preseed.cfg
[[ $? -eq '0' ]] && echo -ne 'Success! \n\n'
} || {
echo -ne 'Not ssl support package! \n\n';
exit 1;
}
}
}
[[ "$ddMode" == '0' ]] && {
sed -i '/anna-install/d' /boot/tmp/preseed.cfg
sed -i 's/wget.*\/sbin\/reboot\;\ //g' /boot/tmp/preseed.cfg
}
[[ "$INCFW" == '1' ]] && [[ "$linuxdists" == 'debian' ]] && [[ -f '/boot/firmware.cpio.gz' ]] && {
gzip -d < ../firmware.cpio.gz | cpio --extract --verbose --make-directories --no-absolute-filenames >>/dev/null 2>&1
}
rm -rf ../initrd.gz;
find . | cpio -H newc --create --verbose | gzip -9 > ../initrd.gz;
rm -rf /boot/tmp;
}
[[ "$inVNC" == 'y' ]] && {
sed -i '$i\\n' $GRUBDIR/$GRUBFILE
sed -i '$r /tmp/grub.new' $GRUBDIR/$GRUBFILE
echo -e "\n\033[33m\033[04mIt will reboot! \nPlease look at VNC! \nSelect\033[0m\033[32m Install OS [$DIST $VER] \033[33m\033[4mto install system.\033[04m\n\n\033[31m\033[04mThere is some information for you.\nDO NOT CLOSE THE WINDOW! \033[0m\n"
echo -e "\033[35mIPv4\t\tNETMASK\t\tGATEWAY\033[0m"
echo -e "\033[36m\033[04m$IPv4\033[0m\t\033[36m\033[04m$MASK\033[0m\t\033[36m\033[04m$GATE\033[0m\n\n"
read -n 1 -p "Press Enter to reboot..." INP
[[ "$INP" != '' ]] && echo -ne '\b \n\n';
}
chown root:root $GRUBDIR/$GRUBFILE
chmod 444 $GRUBDIR/$GRUBFILE
sleep 3 && reboot >/dev/null 2>&1
注意事项: 在安装Ubuntu时,可能会遇到: Getting the time form a network time server... 界面进度条很长时间不会动,可以等待它超时或者更换别的版本. 该问题是Ubuntu系统的问题.